move = 1
currMove = 1
currTry = 1
nextMove = {
    { 2, 4, 3 },
    { 3, 1, 4 },
    { 4, 2, 1 },
    { 1, 3, 2 }
}
oppositeMove = { 3, 4, 1, 2 }
 
observation = 1
currObservation = 1
nextObservation = nextMove
 
ExtractEnemyPositions = function(obs)
    enemies = {}
    numEnemies = 0
    numEntities = #(obs["entities"])
    for i = 1, numEntities do
        if (obs["entities"][i]["type"] == 4) then
            numEnemies = numEnemies + 1
            enemies[numEnemies] = obs["entities"][i]["position"]
        end
    end
    return numEnemies, enemies
end
 
SearchForEnemy = function ()
    sret, stamina = sta.stamina()
    oret = 0
 
    observation = 1
    -- Search for enemies in all directions (as long as we have enough stamina)
    while ((stamina > 10) and (oret == 0) and (observation <= 4)) do
        oret, obs = per.observe(observation)
        sret, stamina = sta.stamina()
 
        nenemies, pos = ExtractEnemyPositions(obs)
        -- If enemies were found, spend stamina attacking them
        if (nenemies > 0) then
            currentEnemy = 1
            per.think("ATKPOS: " .. tostring(pos[currentEnemy][0]) .. " " .. tostring(pos[currentEnemy][1]))
            while (stamina > 5) and (currentEnemy <= nenemies) do
                act.attack(pos[currentEnemy][0], pos[currentEnemy][1])
                currentEnemy = currentEnemy + 1
            end
        end
 
        observation = observation + 1
        sret, stamina = sta.stamina()
    end
end
 
Move = function ()
    nret = act.move(move)
    while (nret ~= 0 and currTry < 4) do
        move = nextMove[currMove][currTry]
        currTry = currTry + 1
        nret = act.move(move)
    end
 
    currTry = 1
    currMove = move
 
    nret, stamina = sta.stamina()
end
 
SetupHero = function ()
    nret = cus.nameCharacter("Rufesio")
    nret = cus.increaseAttribute("str")
end
 
ExecuteHeroTurn = function ()
    -- find doors (except behind)
    for i = 1, 4 do
        if i ~= oppositeMove[move] then
            nret = act.closeDoor(i)
            nret = act.openDoor(i)
            if nret == 0 then
                move = i
                break
            end
        end
    end
 
    Move()
    SearchForEnemy()
end